import requests
import json

def make_post_b2b_request(endpoint, token, order_id, status):
    headers = {
        'Authorization': f'Bearer {token}',
        'Accept': 'application/json',
        'Content-Type': 'application/json' 
    }
    payload = {
        "type": 2,
        "comment": order_id + " STATUS: " + status
    }

    response = requests.post(endpoint.format(apilo_id), headers=headers, json=payload)
    return response

def create_shipment_tracking(endpoint, token, tracking):
    headers = {
        'Authorization': f'Bearer {token}',
        'Accept': 'application/json',
        'Content-Type': 'application/json' 
    }

    trackings = tracking.split(',')

    current_id_external = 1

    for single_tracking in trackings:
        payload = {
            "idExternal": str(current_id_external),
            "tracking": single_tracking.strip(),
            "carrierProviderId": 25
        }

        response = requests.post(endpoint.format(apilo_id), headers=headers, json=payload)

        current_id_external += 1

    return response

def send_tracking_paymentdelivery(endpoint, token, order_id, tracking):
    headers = {
        'Authorization': f'Bearer {token}',
        'Accept': 'application/json',
        'Content-Type': 'application/json' 
    }

    payload = {
        "type": 2,
        "comment":"Przesyłka pobraniowa: "+order_id + " Tracking: " + tracking
    }

    response = requests.post(endpoint.format(apilo_id), headers=headers, json=payload)
    return response


if __name__ == "__main__":
    with open('/usr/home/shumeeshumee/domains/python.shumeeshumee.usermd.net/public_python/Apilo_token_refresher/response.json', 'r') as file:
        response_data = json.load(file)
        access_token = response_data.get('accessToken', '')

    with open('json_entry.json', 'r') as file:
        orders = json.load(file)

    api_endpoint_note = 'https://shumee.apilo.com/rest/api/orders/{}/note/'
    api_endpoint_shipping = 'https://shumee.apilo.com/rest/api/orders/{}/shipment/'

    for order in orders:
        order_id = order.get('id')
        change_id = order.get('state')
        status = order.get('status_order_name')
        tracking = order.get('shipping_tracking')
        apilo_id = order.get('comments_customer')

        if change_id == 1:
            result = make_post_b2b_request(api_endpoint_note, access_token, order_id, status)
            print(result.status_code)
        elif change_id == 2:
            result = make_post_b2b_request(api_endpoint_note, access_token, order_id, status)
            print(result.status_code)
        elif change_id == 3:
            result = make_post_b2b_request(api_endpoint_note, access_token, order_id, status)
            tracking_result = create_shipment_tracking(api_endpoint_shipping, access_token, tracking)
            print(tracking_result.status_code)
        elif change_id == 4:
            result = send_tracking_paymentdelivery(api_endpoint_note, access_token, order_id, tracking)
            print(result.status_code)
